"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var AppModule_1;
const common_1 = require("@nestjs/common");
const cli_module_1 = require("./modules/cli/cli.module");
const node_version_module_1 = require("./modules/node-version/node.version.module");
const app_service_1 = require("./app.service");
const npm_dependency_version_module_1 = require("./modules/npm-dependency-version/npm.dependency.version.module");
const rate_limit_module_1 = require("./modules/rate-limit/rate.limit.module");
const presenter_module_1 = require("./modules/presenter/presenter.module");
const cumulative_stream_1 = require("./util/cumulative.stream");
let AppModule = AppModule_1 = class AppModule {
    static forApi() {
        const streamProvider = {
            provide: 'STREAM',
            useFactory: () => new cumulative_stream_1.CumulativeWritable({})
        };
        return {
            module: AppModule_1,
            providers: [streamProvider],
            exports: [streamProvider],
        };
    }
    static forCli() {
        const streamProvider = {
            provide: 'STREAM',
            useValue: process.stdout
        };
        return {
            module: AppModule_1,
            imports: [cli_module_1.CliModule],
            providers: [streamProvider],
            exports: [streamProvider],
        };
    }
};
AppModule = AppModule_1 = __decorate([
    common_1.Global(),
    common_1.Module({
        imports: [
            presenter_module_1.PresenterModule,
            rate_limit_module_1.RateLimitModule,
            node_version_module_1.NodeVersionModule,
            npm_dependency_version_module_1.NpmDependencyVersionModule,
        ],
        providers: [
            app_service_1.AppService,
        ],
        exports: [
            app_service_1.AppService,
        ],
    })
], AppModule);
exports.AppModule = AppModule;
//# sourceMappingURL=app.module.js.map