import { IProgramOptions, IReportItem } from "../../interfaces";
import { OctokitService } from "../octokit/octokit.service";
import { PresenterService } from "../presenter/presenter.service";
export declare abstract class BaseReportService<T extends IReportItem> {
    protected octokitService: OctokitService;
    protected presenterService: PresenterService;
    constructor(octokitService: OctokitService, presenterService: PresenterService);
    protected abstract handleRepo(repo: string, options: IProgramOptions): Promise<T>;
    getReport(options: IProgramOptions): Promise<T[]>;
    private getRepoReport;
}
