"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const lodash_decorators_1 = require("lodash-decorators");
const commander_service_1 = require("./commander.service");
const inquirer_service_1 = require("./inquirer.service");
const input_validator_service_1 = require("./input.validator.service");
let CliService = class CliService {
    constructor(inquirerService, commanderService, inputValidatorService) {
        this.inquirerService = inquirerService;
        this.commanderService = commanderService;
        this.inputValidatorService = inputValidatorService;
    }
    getProgramOptions() {
        const options = this.commanderService.getProgramOptions();
        return this.patchOptions(options);
    }
    patchOptions(options) {
        return __awaiter(this, void 0, void 0, function* () {
            let localOptions = Object.assign({}, options);
            let validationResult = yield this.inputValidatorService.validate(localOptions);
            while (this.isResultInvalid(validationResult)) {
                const patch = yield this.getOptionsPatch(validationResult.askAbout);
                localOptions = Object.assign({}, localOptions, patch);
                validationResult = yield this.inputValidatorService.validate(localOptions);
            }
            return localOptions;
        });
    }
    getOptionsPatch(askAbout) {
        return __awaiter(this, void 0, void 0, function* () {
            switch (askAbout) {
                case 'owner':
                    return this.inquirerService.promptOwner();
                case 'mode':
                    return this.inquirerService.promptMode();
            }
        });
    }
    isResultInvalid(result) {
        return !result.valid;
    }
};
__decorate([
    lodash_decorators_1.Memoize(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], CliService.prototype, "getProgramOptions", null);
CliService = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [inquirer_service_1.InquirerService,
        commander_service_1.CommanderService,
        input_validator_service_1.InputValidatorService])
], CliService);
exports.CliService = CliService;
//# sourceMappingURL=cli.service.js.map