"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const interfaces_1 = require("./interfaces");
let InputValidatorService = class InputValidatorService {
    validate(options) {
        const mode = this.getMode(options);
        switch (mode) {
            case interfaces_1.Mode.NODE:
            case interfaces_1.Mode.PACKAGE:
                if (!this.getOwner(options)) {
                    return { valid: false, askAbout: 'owner' };
                }
            case interfaces_1.Mode.RATE_LIMIT:
                return { valid: true };
            default:
                return { valid: false, askAbout: 'mode' };
        }
    }
    getMode({ node, package: packageName, rateLimit }) {
        if (node) {
            return interfaces_1.Mode.NODE;
        }
        if (packageName) {
            return interfaces_1.Mode.PACKAGE;
        }
        if (rateLimit) {
            return interfaces_1.Mode.RATE_LIMIT;
        }
        return null;
    }
    getOwner({ org, user }) {
        return org || user || null;
    }
};
InputValidatorService = __decorate([
    common_1.Injectable()
], InputValidatorService);
exports.InputValidatorService = InputValidatorService;
//# sourceMappingURL=input.validator.service.js.map