"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const octokit_service_1 = require("../octokit/octokit.service");
const presenter_service_1 = require("../presenter/presenter.service");
const base_report_service_1 = require("../base/base.report.service");
let NodeVersionService = class NodeVersionService extends base_report_service_1.BaseReportService {
    constructor(octokitService, presenterService) {
        super(octokitService, presenterService);
    }
    handleRepo(repo, options) {
        return __awaiter(this, void 0, void 0, function* () {
            const { org, user, nvm, engines, token } = options;
            const [nvmVersion, enginesVersion] = yield Promise.all([
                nvm ? this.getNvmrc(org || user, repo, token).catch(() => null) : null,
                engines ? this.getEngines(org || user, repo, token).catch(() => null) : null
            ]);
            const data = { repo };
            if (nvm) {
                data.nvmVersion = nvmVersion;
            }
            if (engines) {
                data.enginesVersion = enginesVersion;
            }
            return data;
        });
    }
    getNvmrc(owner, repo, token) {
        return __awaiter(this, void 0, void 0, function* () {
            const content = yield this.octokitService.getFileContent(owner, repo, '.nvmrc', token);
            return content.trim();
        });
    }
    getEngines(owner, repo, token) {
        return __awaiter(this, void 0, void 0, function* () {
            const packageJson = yield this.octokitService.getPackageJson(owner, repo, token);
            const engines = packageJson.engines;
            if (!engines || !engines.node) {
                return null;
            }
            return engines.npm
                ? `${engines.node} (npm: ${engines.npm})`
                : `${engines.node}`;
        });
    }
};
NodeVersionService = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [octokit_service_1.OctokitService,
        presenter_service_1.PresenterService])
], NodeVersionService);
exports.NodeVersionService = NodeVersionService;
//# sourceMappingURL=node.version.service.js.map