"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const octokit_service_1 = require("../octokit/octokit.service");
const package_lock_version_service_1 = require("./package.lock.version.service");
const yarn_lock_version_service_1 = require("./yarn.lock.version.service");
const presenter_service_1 = require("../presenter/presenter.service");
const base_report_service_1 = require("../base/base.report.service");
let NpmDependencyVersionService = class NpmDependencyVersionService extends base_report_service_1.BaseReportService {
    constructor(octokitService, presenterService, packageLockVersionService, yarnLockVersionService) {
        super(octokitService, presenterService);
        this.packageLockVersionService = packageLockVersionService;
        this.yarnLockVersionService = yarnLockVersionService;
    }
    handleRepo(repo, options) {
        return __awaiter(this, void 0, void 0, function* () {
            const { deps, devDeps, peerDeps, packageLock, yarnLock, user, org, token, package: packageName } = options;
            const owner = user || org;
            const packageJson = yield this.octokitService.getPackageJson(owner, repo, token);
            const depVersion = deps && this.getDependencyVersion(packageJson, packageName, 'dependencies');
            const devDepVersion = devDeps && this.getDependencyVersion(packageJson, packageName, 'devDependencies');
            const peerDepVersion = peerDeps && this.getDependencyVersion(packageJson, packageName, 'peerDependencies');
            const version = ([
                depVersion,
                devDepVersion && `${devDepVersion} (dev)`,
                peerDepVersion && `${peerDepVersion} (peer)`
            ])
                .filter(x => x)
                .join(', ') || null;
            const data = { repo, version };
            if (packageLock) {
                data.packageLockVersion = yield this.packageLockVersionService.getVersion(owner, repo, packageName, token).catch(() => null);
            }
            if (yarnLock) {
                data.yarnLockVersion = yield this.yarnLockVersionService.getVersion(owner, repo, packageName, token).catch(() => null);
            }
            return data;
        });
    }
    getDependencyVersion(packageJson, depName, field = 'dependencies') {
        const dependencies = packageJson ? packageJson[field] : null;
        const packageVersion = dependencies ? dependencies[depName] : null;
        return packageVersion;
    }
};
NpmDependencyVersionService = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [octokit_service_1.OctokitService,
        presenter_service_1.PresenterService,
        package_lock_version_service_1.PackageLockVersionService,
        yarn_lock_version_service_1.YarnLockVersionService])
], NpmDependencyVersionService);
exports.NpmDependencyVersionService = NpmDependencyVersionService;
//# sourceMappingURL=npm.dependency.version.service.js.map