"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const lodash_1 = require("lodash");
const octokit_service_1 = require("../octokit/octokit.service");
let PackageLockVersionService = class PackageLockVersionService {
    constructor(octokitService) {
        this.octokitService = octokitService;
    }
    getVersion(owner, repo, packageName, token) {
        return __awaiter(this, void 0, void 0, function* () {
            const packageLock = yield this.getPackageLock(owner, repo, token);
            const rootVersion = lodash_1.get(packageLock, `dependencies.${packageName}.version`, null);
            if (!rootVersion) {
                return rootVersion;
            }
            let isRootVersionUsed = false;
            const versions = Object.keys(packageLock.dependencies)
                .map((dep) => {
                const isRequired = lodash_1.get(packageLock, `dependencies.${dep}.requires.${packageName}`, null);
                if (!isRequired) {
                    return null;
                }
                const innerVersion = lodash_1.get(packageLock, `dependencies.${dep}.dependencies.${packageName}.version`, null);
                if (!innerVersion) {
                    isRootVersionUsed = true;
                }
                return {
                    host: dep,
                    version: innerVersion || rootVersion,
                };
            })
                .filter((item) => item);
            if (!isRootVersionUsed) {
                versions.push({
                    host: '<root>',
                    version: rootVersion,
                });
            }
            return versions.map(({ host, version }) => `${version} for ${host}`);
        });
    }
    getPackageLock(owner, repo, token) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                return JSON.parse(yield this.octokitService.getFileContent(owner, repo, 'package-lock.json', token));
            }
            catch (e) {
                return null;
            }
        });
    }
};
PackageLockVersionService = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [octokit_service_1.OctokitService])
], PackageLockVersionService);
exports.PackageLockVersionService = PackageLockVersionService;
//# sourceMappingURL=package.lock.version.service.js.map