/// <reference types="node" />
import * as Octokit from '@octokit/rest';
import { TableService } from '../table/table.service';
import { IPresenterService } from './interfaces';
import { IReportItem, IProgramOptions } from '../../interfaces';
import { Writable } from 'stream';
export declare class DefaultPresenterService implements IPresenterService {
    private tableService;
    protected stream: Writable;
    private spinner;
    constructor(tableService: TableService, stream: Writable);
    write(str: string): void;
    configure(): void;
    showFiglet(): void;
    showGithubTokenInfo(options: IProgramOptions): void;
    showRateLimit(rateLimit: Octokit.RateLimitGetResponseRate): void;
    showError(message: string): void;
    showData(report: IReportItem[], options: IProgramOptions): void;
    showSpinner(message: string): void;
    showProcessingSpinner(options: IProgramOptions): void;
    hideSpinner({ success, message }: {
        success: boolean;
        message: string;
    }): void;
    protected getWhatToSearch(options: IProgramOptions): string;
    protected getWhereToSearch(options: IProgramOptions): string;
    protected getRepoToSearch(options: IProgramOptions): string;
}
