/// <reference types="node" />
import * as Octokit from "@octokit/rest";
import { Writable } from "stream";
import { IProgramOptions, IReportItem } from "../../interfaces";
import { IPresenterService } from "./interfaces";
export declare class MarkdownPresenterService implements IPresenterService {
    protected stream: Writable;
    constructor(stream: Writable);
    private convertToCsv;
    protected write(data: object): void;
    showFiglet(): void;
    showGithubTokenInfo(): void;
    showRateLimit(rateLimit: Octokit.RateLimitGetResponseRate, isMainInfo: boolean): Promise<void>;
    showError(message: string): void;
    showData(report: IReportItem[], options: IProgramOptions): void;
    showSpinner(): void;
    showProcessingSpinner(): void;
    hideSpinner(): void;
}
