import * as Octokit from '@octokit/rest';
import { PresentationMode, IPresenterService } from './interfaces';
import { DefaultPresenterService } from './default.presenter.service';
import { JsonPresenterService } from './json.presenter.service';
import { IReportItem, IProgramOptions } from '../../interfaces';
import { RawJsonPresenterService } from './raw.json.presenter.service';
import { CsvPresenterService } from './csv.presenter.service';
export declare class PresenterService implements IPresenterService {
    private defaultPresenterService;
    private jsonPresenterService;
    private rawJsonPresenterService;
    private csvPresenterService;
    private static mode;
    static setMode(mode: PresentationMode): void;
    constructor(defaultPresenterService: DefaultPresenterService, jsonPresenterService: JsonPresenterService, rawJsonPresenterService: RawJsonPresenterService, csvPresenterService: CsvPresenterService);
    private readonly presenter;
    showFiglet(): void;
    showGithubTokenInfo(options: IProgramOptions): void;
    showRateLimit(rateLimit: Octokit.RateLimitGetResponseRate, isMainInfo: boolean): void;
    showError(message: any): void;
    showData(report: IReportItem[], options: IProgramOptions): void;
    showSpinner(message: string): void;
    showProcessingSpinner(options: IProgramOptions): void;
    hideSpinner({ success, message }: {
        success: boolean;
        message?: string;
    }): void;
}
