"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var PresenterService_1;
const common_1 = require("@nestjs/common");
const interfaces_1 = require("./interfaces");
const default_presenter_service_1 = require("./default.presenter.service");
const json_presenter_service_1 = require("./json.presenter.service");
const raw_json_presenter_service_1 = require("./raw.json.presenter.service");
const csv_presenter_service_1 = require("./csv.presenter.service");
let PresenterService = PresenterService_1 = class PresenterService {
    constructor(defaultPresenterService, jsonPresenterService, rawJsonPresenterService, csvPresenterService) {
        this.defaultPresenterService = defaultPresenterService;
        this.jsonPresenterService = jsonPresenterService;
        this.rawJsonPresenterService = rawJsonPresenterService;
        this.csvPresenterService = csvPresenterService;
    }
    static setMode(mode) {
        PresenterService_1.mode = mode;
    }
    get presenter() {
        switch (PresenterService_1.mode) {
            case interfaces_1.PresentationMode.RAW_JSON:
                return this.rawJsonPresenterService;
            case interfaces_1.PresentationMode.JSON:
                return this.jsonPresenterService;
            case interfaces_1.PresentationMode.CSV:
                return this.csvPresenterService;
            case interfaces_1.PresentationMode.DEFAULT:
            default:
                return this.defaultPresenterService;
        }
    }
    showFiglet() {
        this.presenter.showFiglet();
    }
    showGithubTokenInfo(options) {
        this.presenter.showGithubTokenInfo(options);
    }
    showRateLimit(rateLimit, isMainInfo) {
        this.presenter.showRateLimit(rateLimit, isMainInfo);
    }
    showError(message) {
        this.presenter.showError(message);
    }
    showData(report, options) {
        this.presenter.showData(report, options);
    }
    showSpinner(message) {
        this.presenter.showSpinner(message);
    }
    showProcessingSpinner(options) {
        this.presenter.showProcessingSpinner(options);
    }
    hideSpinner({ success, message }) {
        this.presenter.hideSpinner({ success, message });
    }
};
PresenterService.mode = interfaces_1.PresentationMode.DEFAULT;
PresenterService = PresenterService_1 = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [default_presenter_service_1.DefaultPresenterService,
        json_presenter_service_1.JsonPresenterService,
        raw_json_presenter_service_1.RawJsonPresenterService,
        csv_presenter_service_1.CsvPresenterService])
], PresenterService);
exports.PresenterService = PresenterService;
//# sourceMappingURL=presenter.service.js.map