"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const Table = require("cli-table3");
const changeCase = require("change-case");
let TableService = class TableService {
    constructor() {
        this.ORDER = Object.freeze({
            'repo': Number.MIN_VALUE,
            'version': -10,
            'packageLockVersion': -11,
            'yarnLockVersion': -12,
            'nvmVersion': -7,
            'enginesVersion': -6,
            'error': Number.MAX_VALUE,
        });
        this.TRANSFORMER = Object.freeze({
            'packageLockVersion': versions => versions && versions.join('\n'),
            'yarnLockVersion': versions => versions && versions.join('\n'),
        });
    }
    format(data, options) {
        const fieldSet = data.reduce((set, item) => {
            Object.keys(item).map(key => {
                set.add(key);
            });
            return set;
        }, new Set());
        const fields = [...fieldSet]
            .filter(this.filterSkippedColumns(options))
            .sort(this.orderColumns());
        const headers = fields.map(field => changeCase.sentenceCase(field));
        const table = new Table({
            head: headers,
        });
        const [key, ...values] = fields;
        data.forEach(item => {
            table.push({
                [item[key]]: values.map(value => this.transform(item[value], value))
            });
        });
        return table.toString();
    }
    transform(value, key) {
        return this.TRANSFORMER[key]
            ? this.TRANSFORMER[key](value)
            : value;
    }
    filterSkippedColumns(options) {
        return (field) => {
            switch (field) {
                case 'packageLockVersion':
                    return options.packageLock;
                case 'yarnLockVersion':
                    return options.yarnLock;
                case 'enginesVersion':
                    return options.engines;
                case 'nvmVersion':
                    return options.nvm;
                default:
                    return true;
            }
        };
    }
    orderColumns() {
        return (fieldA, fieldB) => (this.ORDER[fieldB] || 0) - (this.ORDER[fieldA] || 0);
    }
};
TableService = __decorate([
    common_1.Injectable()
], TableService);
exports.TableService = TableService;
//# sourceMappingURL=table.service.js.map